#include<stdio.h>
#include<stdlib.h>
#include<conio.h>

FILE * F;

int month_array[8][73]; // 7 x 72 array

char * name_of_month[13]={" ",
"  ",
" ",
"    ",
"  ",
"     ",
"    ",
"    ",
"  ",
"",
" ",
"  ",
" "};


char * name_of_day[8]={"  ",
"",
"",
"",
"",
"",
"",
""};

int wait(void) { return getch();}

int is_leap_year(int year)
{
  if(year < 0) year = -year; 
  return ((year % 400 == 0) || ((year % 100 != 0) && (year % 4 == 0)));
}

int number_of_days(int year, int month)
{
 if ((month == 4) || (month == 6) || (month == 9) || (month == 11))
      return 30;
 else if (month == 2)
        if(is_leap_year(year)) return 29; else return 28;
        else return 31;
}

int next_day (int this_day)
{
  if(this_day == 7) return 1; else return ++this_day;
}

int previous_day (int this_day)
{
  if(this_day == 1) return 7; else return --this_day;
}

int first_day_of_year(int year)
{ int day, y;
  day = 7;
  if(year >= 1984) 
    for(y = 1984; y <= year - 1; y++)
       if(is_leap_year(y)) day = next_day(next_day(day));
                           else day = next_day(day);
  else
    for(y = 1983; y >= year; y--)
       if(is_leap_year(y)) day = previous_day(previous_day(day));
                           else day = previous_day(day);

  return day;
}

void make_calendar(int year)
{ int i,j;
  int line, column;

  for(i = 1; i <= 7; i++)
    for(j = 1; j <= 72; j++)
       month_array[i][j] = 0;

  line = first_day_of_year(year);
  for(i = 1; i <= 12; i++)
    { column = (i - 1) * 6 + 1;
      for(j = 1; j <= number_of_days(year, i); j++)
        {
          month_array[line][column] = j;

          if(line == 7) {line = 1; column ++;}
                   else  line++;
        }
    }
}

void print_calendar(int year, int number_of_columns)
{ int i, j, k;

  if(year > 0)
    {
     for(i=1; i <= (2 + 18 * number_of_columns) / 2 - 2; i++) fprintf(F, " ");
     fprintf(F, "%d\n",year);
    }
  else 
    {
     for(i=1; i <= (2 + 18 * number_of_columns) / 2 - 4; i++) fprintf(F, " ");
     fprintf(F, "%d  ..\n", 1 - year);
    }
  fprintf(F, "\n");
  for(i = 1; i <= 12; i += number_of_columns)
    { fprintf(F, "%s", name_of_day[0]);
      for(j=1; (j <= number_of_columns) && (i + j - 1 <= 12); j++)
              fprintf(F, "     %s     ", name_of_month[i+j-1]);
      fprintf(F, "\n\n");
      for(k=1; k <= 7; k++)
        {
	  fprintf(F, "%s", name_of_day[k]);
          for(j = 1; (j <= number_of_columns * 6) && ((i-1)*6 + j <= 72); j++)
            {
              if(month_array[k][ (i-1)*6 + j ] == 0)
                fprintf(F, "   ");
              else  
                fprintf(F, " %2d",
                 month_array[k][ (i-1)*6 + j ]);

            }
          fprintf(F, "\n");
        }
      fprintf(F, "\n");
    }
}

main(int narg, char *vectarg[])
{ int col, year;
  char name[13];

  if(narg<=2)
  {
   printf("\n Outputs a calendar to a text file in cp-1251 encoding");
   printf("\n Usage: CALENDAR year number_of_columns");
   printf("\n AD: year > 0");
   printf("\n BC: year < 0");
   printf("\n 1 <= number_of_columns <= 12");
   printf("\n Example: calendar 1755 3");
   printf("\n Example: calendar -753 4");
   printf("\n          (753 BC, the year of the foundation of Rome)");
   wait();return 0;
  }
  year = atoi(vectarg[1]);
  col  = atoi(vectarg[2]);


  if((col <= 0) || (col > 12))
      { printf("\n **** Invalid number of columns");
        wait(); return 0;
      }

  if(year == 0)
      { printf("\n **** Invalid year");
        wait(); return 0;
      }
  if(year > 0)
    sprintf(name, "%d_%d.txt", year,col);
  else
    sprintf(name, "%dBC%d.txt", -year,col);
  F = fopen(name,"wt");

  if(year < 0) year++;

  make_calendar(year);
  print_calendar(year, col);

  fclose(F);
  return 0;
}


